# Import AzureAD module
Import-Module "C:\Program Files (x86)\WindowsPowerShell\Modules\AzureAD\2.0.2.182\AzureAD.psd1"

# Load the encrypted password and decrypt it
$encryptedPassword = Get-Content C:\scripts\JMLProcess\encrypted.txt | ConvertTo-SecureString

# Create a PSCredential object using the decrypted password
# Replace "yourusername@domain.com" with the actual username
$credential = New-Object System.Management.Automation.PSCredential("yourusername@domain.com", $encryptedPassword)

# Connect to Azure AD using the stored credentials
Connect-AzureAD -Credential $credential

# Read CSV data into a variable
$csvData = Import-Csv -Path "C:\scripts\JMLProcess\CompassFiles\members.csv.csv"

# Get all Azure AD users
$users = Get-AzureADUser -All $true

# Handle leavers
foreach ($user in $users) {
    $employeeId = $user.ExtensionProperty.employeeId

    if ($null -eq $employeeId) {
        # Check if user is a part of JML_Excluded group
        $groupMemberExcluded = Get-AzureADUserMembership -ObjectId $user.ObjectId | Where-Object {$_.DisplayName -eq 'JML_Excluded'}
        
        # Check if user is already a part of JML_Disabled group
        $groupMemberDisabled = Get-AzureADUserMembership -ObjectId $user.ObjectId | Where-Object {$_.DisplayName -eq 'JML_Disabled'}
        
        if ($null -eq $groupMemberExcluded -and $null -eq $groupMemberDisabled) {
            # Move user to JML_Disabled group
            Add-AzureADGroupMember -ObjectId (Get-AzureADGroup -SearchString 'JML_Disabled').ObjectId -RefObjectId $user.ObjectId
            $log += "Moved user $($user.UserPrincipalName) to JML_Disabled`r`n"
        }
        
        continue
    }
}
# Output log
$log | Out-File -FilePath "C:\scripts\JMLProcess\Scheduled_Logs\Leavers_Log.txt" -Append
