# Load the encrypted password and decrypt it
$encryptedPassword = Get-Content C:\scripts\JMLProcess\encrypted.txt | ConvertTo-SecureString

# Create a PSCredential object using the decrypted password
# Replace "yourusername@domain.com" with the actual username
$credential = New-Object System.Management.Automation.PSCredential("yourusername@domain.com", $encryptedPassword)

# Connect to Azure AD using the stored credentials
Connect-AzureAD -Credential $credential

# Read CSV data into a hashtable
$csvData = Import-Csv -Path "C:\scripts\JMLProcess\CompassFiles\members.csv.csv"
$contactNumberHash = @{}
foreach ($row in $csvData) {
    $contactNumberHash[$row.contact_number] = $row
}

# Fetch all AzureAD users
$users = Get-AzureADUser -All $true

foreach ($user in $users) {
    $employeeId = $user.ExtensionProperty.employeeId

    # Skip updating if the UPN matches 'charles.kemp@brscouts.org.uk'
    if ($user.UserPrincipalName -eq 'charles.kemp@brscouts.org.uk') {
        Write-Host "Skipping updates for $($user.UserPrincipalName)"
        continue
    }

    if ($null -eq $employeeId) {
        continue
    }

    $csvRow = $contactNumberHash[$employeeId]
    
    if ($null -eq $csvRow) {
        continue
    }

    # Update JobTitle if it doesn't match
    if ($csvRow.Role -ne $user.JobTitle) {
        Set-AzureADUser -ObjectId $user.ObjectId -JobTitle $csvRow.Role
        Write-Host "Updated JobTitle for $($user.DisplayName) to $($csvRow.Role)"
    }
    }

    # Update Department if it doesn't match
    if ($csvRow.At -ne $user.Department) {
        Set-AzureADUser -ObjectId $user.ObjectId -Department $csvRow.At
        Write-Host "Updated Department for $($user.DisplayName) to $($csvRow.At)"
    }


